|	byteio.g - provides putchar, getchar, getchar_nb, put_attr_xy,
|	vid_init, and clrscr
|	Greg Alexander - 99/8/6


|	putchar - ( char -- )
|	outputs char to the screen using the monitor (trap 15 function 0)
|	shouldn't be used after vid_init -- after that, try put_attr_xy
:putchar
"	move.l	+(SP),D0
"	trap	#15
"	.word	1
;


|	getchar - ( -- char )
|	gets a char from the buffer made by the keyboard ISR (does not use
|	the monitor) -- blocks until one is ready
:getchar	.dequeue .dup getchar_got getchar_help >ifte
'getchar_help	.drop >getchar


|	getchar_nb - ( -- char )
|	like getchar, but non-blocking (pushes -1 on no key available)
:getchar_nb	.dequeue .dup getchar_got getchar_nb_help >ifte
'getchar_nb_help .drop -1 ;

|	getchar_got - ( char -- char )
|	takes a char from dequeue that has the high bit set and clears it
'getchar_got	0xff >andb

|	put_attr_xy - ( char attr x y -- )
|	puts char with attributes attr at locations x and y, directly
|	into video memory (must call vid_init first)
:put_attr_xy	80 .times .add 2 .times vid_mem .add | ( char attr addr )
	.rot .swap 256 .times .add .swap >atw


|	vid_init - ( -- )
|	initializes video for Greg's direct access words (just sets
|	start reg, pretty much), also clears screen
:vid_init	0x0c vid_addr_reg .atb	| set the first byte of start reg
		0x00 vid_data_reg .atb
		0x0d vid_addr_reg .atb	| set the second byte of start reg
		0x00 vid_data_reg .atb
		>clrscr

|	clrscr - ( -- )
|	clears the screen
:clrscr	4000 >clrscr_help
'clrscr_help	2 .sub .dup vid_mem .add 0x2007 .swap .atw .dup
	clrscr_help drop >ifte
	

|	declaration of assembler constants
"vid_mem	= 0x7f7b8000
"vid_addr_reg	= 0x7f6003d4
"vid_data_reg	= 0x7f6003d5
