#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

void handle_item(char *s);

int main(void)
{
	char s[1000],*ss,*t;
	while (fgets(s,1000,stdin)) {
		s[strcspn(s,"|\r\n")]=0;	/* strip CR/LF/comments */
		ss=s;
		while (*ss) {
			ss+=strspn(ss," \t");	/* skip whitespace */
			t=ss;
/*			printf("bbb:%s;\n",ss); */
			if (*t=='"') {		/* if it's a ", then it's */
						/* straight asm */
				printf("%s\n",t+1);
				break;
			} else if (*t) {
				ss+=strcspn(ss," \t");
				if (*ss)
					*ss++=0;
				handle_item(t);
			}
		}
	}
	return 0;
}

void handle_item(char *s)
{
/*	printf("asdf:%s;\n",s);*/
	if (isalnum((int)(*s)) || *s=='-') {/* it's an assembler symbol, push it */
		printf("\tmove.l\t#%s,-(A6)\n",s);
		return;
	}
	switch(*s++) {
		case ':':	/* it's a global word start */
			printf("\n.globl %s\n%s:\n",s,s);
			break;
		case '\'':	/* it's a local word start */
			printf("\n%s:\n",s);
			break;
		case ';':	/* it's an end of word */
			printf("\trts\n\n");
			break;
		case '?':	/* it's a local variable decl */
			printf("%s:\t.long 0\n",s);
			break;
		case '/':	/* it's a global variable decl */
			printf(".globl %s\n%s:\t.long 0\n",s,s);
			break;
		case '.':	/* it's a word call */
			printf("\tjsr\t%s\n",s);
			break;
		case '>':	/* it's a tail-optimized word call */
			printf("\tjmp\t%s\n\n",s);
			break;
		case ',':	/* it's a variable value reference */
			printf("\tmove.l\t%s,-(A6)\n",s);
			break;
		default:
			fprintf(stderr,"BUH:%s;\n",s);
			break;
	}
}
