|	print.g - provides printing functions (print_str, print_nibble,
|	print_byte, print_word, print_long)
|	Greg Alexander - 99/8/6


|	print_str - ( attr x y string -- )
|	prints string at x,y with attribute attr
:print_str	.dup print_str_string .at	| save the string
	.bangb print_str_helper >ift
|	print_str_helper - ( attr x y -- )
'print_str_helper
	.dup3 ,print_str_string .bangb .rot4 .put_attr_xy | put the char
	print_str_string .inc .swap 1 .add .swap	| increment str&col
	,print_str_string .bangb print_str_helper drop3 >ifte
?print_str_string


|	print_nibble - ( attr x y nibble -- )
|	prints that hex nibble
:print_nibble	0x0f .andb hex_table .add .bangb .rot4 >put_attr_xy


|	print_byte - ( attr x y byte -- )
|	prints the byte in hex
:print_byte	.dup4 4 .lsr .print_nibble		| print big nibble
	.unrot 1 .add .rot >print_nibble		| print small nibble


|	print_word - ( attr x y word -- )
:print_word	.dup4 8 .lsr .print_byte		| print big byte
		.unrot 2 .add .rot >print_byte		| print small byte


|	print_long - ( attr x y long -- )
:print_long	.dup4 16 .lsr .print_word		| print big word
		.unrot 4 .add .rot >print_word		| print small word


|	strings:
"hex_table: .ascii "0123456789abcdef"
".even
