|	queue.g - handles the circular queue for keyboard input
|	Greg Alexander - 99/8/6
|	Provides two functions, enqueue and dequeue to add something
|	onto the tail of the queue or take something off of the head
|	respectively.  The first interesting character to read is head+1
|	and new characters are written at tail+1


|	enqueue - ( char -- )
|	adds a character to the tail of the queue
|	on queue overflow, it silently discards the char
:enqueue	,tail 1 .add 0xff .andb .dup ,head .eq	| check for overflow
	drop2 enqueue_add >ifte
'enqueue_add	.dup tail .at queue .add >atb	| put it in the queue
	

|	dequeue - ( -- char )
|	If there is a character to be read, it returns it and sets the
|	high bit to 1 (so that we can tell the difference between an
|	underflow and a null), otherwise pushes a 0
:dequeue	,head .dup ,tail .eq dequeue_uf dequeue_get >ifte
'dequeue_uf	.drop 0	;			| handle underflow
'dequeue_get	1 .add 0xff .andb .dup head .at	| increment the head
	queue .add .bangb			| grab the char
	0x80000000 >orb			| set the high bit


|	variables:
"queue:	.=.+ 256	| if you change the size, you'll need to
"			| change the way that wrap-over is implemented
?head
?tail
